<script lang="ts">
import Vue from 'vue';
import { SlpColumn } from '../common/index.vue';

export default Vue.extend({
  name: 'FifteenCountdown',
  components: { SlpColumn },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      counter: '',
    };
  },
  mounted() {
    this.startCountdown();
  },
  methods: {
    startCountdown() {
      const interval = setInterval(() => {
        const now = new Date().getTime();
        const distance = this.data.target_timestamp - now;

        const days = Math.floor(distance / (1000 * 60 * 60 * 24));
        const hours = Math.floor(
          (distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60),
        );
        const minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
        const seconds = Math.floor((distance % (1000 * 60)) / 1000);

        this.counter = `${days} Days, ${hours} Hours, ${minutes} Minutes, ${seconds} Seconds`;

        if (distance < 0) {
          clearInterval(interval);
          this.counter = `0 Days, 0 Hours, 0 Minutes, 0 Seconds`;
        }
      }, 1000);
    },
  },
});
</script>

<template>
  <section class="fifteen-countdown">
    <SlpRow>
      <SlpColumn class="fifteen-countdown__header">
        <SlpTypography
          tag="h2"
          variant="heading2-bold"
          class="slp-mb-24"
          data-aos="fade-up"
          data-aos-duration="600"
          data-aos-delay="800"
          >{{ data.title }}
        </SlpTypography>
        <SlpTypography
          tag="p"
          variant="body1"
          class="slp-mb-24"
          data-aos-duration="900"
          data-aos-delay="800"
          >{{ data.text }}
        </SlpTypography>
        <SlpButton
          v-if="data.link"
          variant="secondary"
          class="fifteen-countdown__register"
          :href="data.link.href"
          data-aos="fade-up"
          data-aos-duration="1500"
          data-aos-delay="800"
        >
          {{ data.link.text }}
          <img class="slp-ml-8" src="/nuxt-images/icons/level-up.svg" alt="" />
        </SlpButton>
      </SlpColumn>
    </SlpRow>
    <SlpRow>
      <SlpColumn>
        <div class="fifteen-countdown__body">
          <SlpTypography
            class="slp-pb-32"
            tag="h4"
            variant="heading3-bold"
            data-aos="fade-up"
            data-aos-duration="1200"
            data-aos-delay="800"
            >{{ data.countdown_text }}
          </SlpTypography>
          <SlpTypography
            class="slp-color-surface-900"
            tag="p"
            variant="heading2-bold"
            data-aos="fade-up"
            data-aos-duration="1200"
            data-aos-delay="800"
            >{{ counter }}
          </SlpTypography>
        </div>
      </SlpColumn>
    </SlpRow>
  </section>
</template>

<style scoped lang="scss">
.fifteen-countdown {
  &__header {
    text-align: center;
    padding: $spacing-64 0;

    @media (min-width: $breakpoint-md) {
      padding-top: 160px;
      padding-bottom: $spacing-96;
    }
  }

  &__body {
    position: relative;
    background: $color-primary-200;
    padding: $spacing-64;
    color: $color-primary-300;
    border-bottom-right-radius: 100px;
    margin-bottom: $spacing-64;

    @media (min-width: $breakpoint-md) {
      margin-bottom: 160px;
    }
  }

  &__register {
    min-width: 100%;
    justify-content: center;

    @media (min-width: $breakpoint-md) {
      min-width: 367px;
    }

    &:hover {
      img {
        filter: invert(100%) sepia(0%) saturate(0%) hue-rotate(205deg)
          brightness(110%) contrast(101%);
      }
    }
  }
}
</style>
